/*
 *  GOL - Game of life simulation software
 *  Copyright (C) 1996 Michael Raymond Brown
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Author: Michael Raymond Brown
 *  EMail:  michael@arrakeen.demon.co.uk
 *  WWW:    http://www.arrakeen.demon.co.uk/
 *  Address:  Michael Brown
 *            Kia Ora
 *            Brook Street
 *            Great Bromley
 *            Nr Colchester
 *            Essex
 *            CO7 7HX
 *            England
 */


#ifdef __GNUC__
#pragma implementation
#endif

#include "SpinBox.h"
#include "ArrowButton.h"
#include <string.h>
#include <stdio.h>

void xwSpinBox::handler::onClick(xwWidget* from, int index)
   {int val = box->getValue();
    int add = box->getStep();
    if (index)
	 val+=add;
    else val-=add;

    box->setValue(val);
   }

void xwSpinBox::init(int pmin, int pmax, int pstep)
   { min = pmin;
     max = pmax;
    step = pstep;
    xwArrowButton* ab1 = new xwArrowButton(this, xwArrowButton::left,0 , 0,0,1,5);
		  text = new xwText(this , 6,1 , 1,0 , 4,5);
    xwArrowButton* ab2 = new xwArrowButton(this, xwArrowButton::right,0 , 4,0,5,5);
    ab1->setHandler(&hand, 0);
    ab2->setHandler(&hand, 1);
    ab1->setAuto(1);
    ab2->setAuto(1);
    setValue(pmin);
   }

xwSpinBox::xwSpinBox(xwWidget* p, int pmin, int pmax, int pstep, int x1, int y1, int x2, int y2) : xwmForm(p, 5, x1, y1, x2, y2), hand(this)
   {init(pmin,pmax,pstep);
   }
xwSpinBox::xwSpinBox(xwWidget* p, int pmin, int pmax, int pstep) : xwmForm(p, 5), hand(this)
   {init(pmin,pmax,pstep);
   }
xwSpinBox::~xwSpinBox()
   {
   }

void xwSpinBox::setValue(int state)
   {char buffer[32];
    if (state<min) state=min;
    if (state>max) state=max;
    value = state;
    sprintf(buffer, "%d", state);
    text->setText(buffer);
   }
int xwSpinBox::getValue()
   {return value;
   }



